﻿/*
 * Jam.js ver 1.00
 * java animation module
 * (c) anabasis.jp
 */

var jamUP = true;
function jamLoadAudio( param ) {
	if ( window.Track0 != null ) delete window.Track0;
	try { window.Track0 = new UnitePlayer( param, 0, null ); }
	catch ( e ) { console.log( "new UnitePlayer() faild." ); }
}

function jamPlayAudio( name ) {
	if ( !jamUP ) return;
	if ( window.Track0 == null ) return;
	window.Track0.preset( name );
}

function jamPauseAudio() {
	if ( !jamUP ) return;
	if ( window.Track0 == null ) return;
	window.Track0.pause();
}

function jamQuitAudio() {
}

function jamSwitchAudio( stat ) {
	jamUP = stat;
}

var jamLR = false; // 低解像度端末
var jamDW = 900; // 画面横幅
var jamDH = 600; // 画面縦幅
var jamIV = 15; // フレーム実行間隔（ミリ秒）
var jamBP1 = ""; // ベンダープレフィクス
var jamBP2 = ""; // ベンダープレフィクス
var jamBT = ""; // ブラウザタイプ
var jamST = ""; // スマートフォンタイプ
var jamSP = false; // スマートフォンか？
var jamWK = false; // Webkit 対応
function jamInit() {
	var userAgent = window.navigator.userAgent.toLowerCase();
	var appVersion = window.navigator.appVersion.toLowerCase();
console.log( "ua = " + userAgent );
	
	if ( -1 < userAgent.indexOf( "msie" ) ) {
		jamBP1 = "-ms-";
		jamBP2 = "ms";
		jamBT = "ie";
		jamWK = false;
	}
	else if ( -1 < userAgent.indexOf( "firefox" ) ) {
		jamBP1 = "-moz-";
		jamBP2 = "Moz";
		jamBT = "ff";
		jamWK = false;
	}
	else if ( -1 < userAgent.indexOf( "opera" ) ) {
		jamBP1 = "-o-";
		jamBP2 = "O";
		jamBT = "op";
		jamWK = false;
	}
	else if ( -1 < userAgent.indexOf( "chrome" ) ) {
		jamBP1 = "-webkit-";
		jamBP2 = "webkit";
		jamBT = "ch";
		jamWK = false;
	}
	else if ( -1 < userAgent.indexOf( "safari" ) ) {
		jamBP1 = "-webkit-";
		jamBP2 = "webkit";
		jamBT = "sf";
		jamWK = false;
	}
	else {
		jamBP1 = "-ms-";
		jamBP2 = "ms";
		jamBT = "ie"; // 未確認の場合はIEとして扱う
		jamWK = false;
 	}
 	
	if ( -1 < userAgent.indexOf( "iphone" ) ) {
		jamST = "i";
		jamSP = true;
//jamWK = true; // iOS は  webkit 対応
	}
	else if ( -1 < userAgent.indexOf( "ipad" ) ) {
		jamST = "i";
		jamSP = true;
//jamWK = true; // iOS は  webkit 対応
	}
	else if ( -1 < userAgent.indexOf( "ipod" ) ) {
		jamST = "i";
		jamSP = true;
//jamWK = true; // iOS は  webkit 対応
	}
	else if ( -1 < userAgent.indexOf( "android" ) ) {
		jamST = "a";
		jamSP = true;
jamWK = false; // android は  webkit 非対応
	}
	else {
		jamST = "";
		jamSP = false;
	}
	
	if ( jamSP ) {
		window.onorientationchange = jamRelocate;
	}
	else {
		window.onresize = jamRelocate;
		document.body.style.overflow = "hidden";
	}
}

function jamTransformBP() {
	//return jamBP1 + "transform";
	return jamBP2 + "Transform";
}
function jamTransitionBP() {
	//return jamBP1 + "transition";
	return jamBP2 + "Transition";
}

var jamTM = false; // touchmove 発生記録フラグ
function jamSetOnClick( elem, func ) {
	if ( jamSP ) {
		jamTM = false;
		//if ( func != null ) elem.ontouchmove = jamTouchMove;
		//else elem.ontouchmove = null;
		elem.ontouchend = func;
	}
	else {
		elem.onclick = func;
	}
}
function jamJudgeOnClick() {
	if ( jamSP ) {
		if ( jamTM ) {
			jamTM = false;
			//return false;
			return true;
		}
		else {
			return true;
		}
	}
	else {
		return true;
	}
}
function jamTouchMove() {
	jamTM = true;
}
function jamEventKiller() {
	event.preventDefault();
}

var jamRD = null;
function jamRootDiv() {
	if ( jamSP ) {
		jamRelocate();
	}
	else {
		if ( jamRD != null ) return;
		var e = document.createElement( "div" );
		e.id = "SystemRootDiv";
		document.body.appendChild( e );
		jamRD = e;
		jamRelocate();
		return e;
	}
}
function jamGetRootElem() {
	if ( jamRD == null ) return document.body;
	else return jamRD;
}
function jamNewDiv( id ) {
	var e = document.createElement( "div" );
	if ( id != null ) e.id = id;
	e.style.opacity = 0; // 初期状態
	if ( jamSP ) {
		e.className = "SPtag";
		document.body.appendChild( e );
		return e;
	}
	else {
		if ( jamRD == null ) return null;
		jamRD.appendChild( e );
		return e;
	}
}
function jamNewDivs( id, count, z ) {
	var e = [];
	for ( var i = 0; i < count; i++ ) {
		e[i] = document.createElement( "div" );
		if ( id != null ) e[i].id = id;
		e[i].style.opacity = 0; // 初期状態
		e[i].style.zIndex = z + i;
		if ( jamSP ) {
			e[i].className = "SPtag";
			document.body.appendChild( e[i] );
		}
		else {
			if ( jamRD == null ) return null;
			jamRD.appendChild( e[i] );
		}
	}
	return e;
}
function jamDelDiv( elem ) {
	if ( elem != null ) {
		jamGetRootElem().removeChild( elem );
	}
	else {
		var e = jamGetRootElem().getElementsByTagName( "div" );
		for ( var i = (e.length - 1); 0 <= i; i-- ) {
			jamGetRootElem().removeChild( e.item(i) );
		}
	}
}
var jamOR = 0;
var jamIW = 0;
var jamIH = 0;
function jamRelocate() {
	var or = window.orientation;
	var iw = window.innerWidth;
	var ih = window.innerHeight;
	
	jamOR = or;
	jamIW = iw;
	jamIH = ih;
}

var jamIM = [];
function jamLoadImage( pname ) {
	jamIM = new Array();
	for ( var i = 0; i < pname.length; i++ ) {
		jamIM[i] = new Image();
		jamIM[i].src = pname[i];
		jamIM[i].onload = function () {
			this.onload = null;
		};
	}
}

function jamIsLoadImage() {
	var count = 0;
	for ( var i = 0; i < jamIM.length; i++ ) {
		if ( jamIM[i].onload != null ) {
			count++;
		}
	}
	return [jamIM.length, count];
}

var jamAC = 0; // アニメ実行数
var jamAT = []; // 各アニメ情報
function jamAnime( arg, callback ) {
	var carg = [];
	{ // 入れ子状の配列を一次元に展開
		var cai = 0;
		var ai = 0;
		while ( arg[ai] != null ) {
			if ( arg[ai] instanceof Array ) {
				for ( var i = 0; i < arg[ai].length; i++ ) {
					if ( arg[ai][i] instanceof Array ) {
						for ( var j = 0; j < arg[ai][i].length; j++ ) {
							if ( arg[ai][i][j] instanceof Array ) {
								for ( var k = 0; k < arg[ai][i][k].length; k++ ) {
									carg[cai++] = arg[ai][i][j][k];
								}
							}
							else {
								carg[cai++] = arg[ai][i][j];
							}
						}
					}
					else {
						carg[cai++] = arg[ai][i];
					}
				}
			}
			else {
				carg[cai++] = arg[ai];
			}
			ai++;
		}
	}
	
	var block = [];
	{ // ブロック単位にパース
		var bi = 0;
		var cai = 0;
		{ // 先頭のダミーラベル
			block[bi] = [];
			block[bi]["what"] = "label";
			block[bi]["span"] = 0;
			block[bi]["func"] = [];
			block[bi]["do1t"] = false;
			block[bi]["name"] = "boot";
			bi++;
		}
		while ( typeof( carg[cai] ) == "string" ) {
			if ( carg[cai] == "time" ) {
				block[bi] = [];
				block[bi]["what"] = carg[cai++];
				block[bi]["span"] = 0;
				block[bi]["func"] = [];
				block[bi]["do1t"] = false;
				if ( (typeof( carg[cai] ) == "number") && (typeof( carg[cai+1] ) == "string") ) {
					block[bi]["span"] = carg[cai++];
					block[bi]["mode"] = carg[cai++];
					var fi = 0;
					while ( typeof( carg[cai] ) == "function" ) {
						block[bi]["func"][fi++] = carg[cai++];
					}
				}
				bi++;
			}
			else if ( carg[cai] == "back" ) {
				block[bi] = [];
				block[bi]["what"] = carg[cai++];
				block[bi]["span"] = 0;
				block[bi]["func"] = [];
				block[bi]["do1t"] = false;
				if ( (typeof( carg[cai] ) == "number") && (typeof( carg[cai+1] ) == "number") ) {
					block[bi]["move"] = carg[cai++];
					block[bi]["loop"] = carg[cai++];
				}
				bi++;
			}
			else if ( carg[cai] == "stop" ) {
				block[bi] = [];
				block[bi]["what"] = carg[cai++];
				block[bi]["span"] = 0;
				block[bi]["func"] = [];
				block[bi]["do1t"] = false;
				bi++;
			}
			else if ( carg[cai] == "if" ) {
				block[bi] = [];
				block[bi]["what"] = carg[cai++];
				block[bi]["span"] = 0;
				block[bi]["func"] = [];
				block[bi]["do1t"] = false;
				if ( (typeof( carg[cai] ) == "function") && (typeof( carg[cai+1] ) == "function") ) {
					block[bi]["cond"] = carg[cai++];
					block[bi]["proc"] = carg[cai++];
				}
				bi++;
			}
			else if ( carg[cai] == "if goto" ) {
				block[bi] = [];
				block[bi]["what"] = carg[cai++];
				block[bi]["span"] = 0;
				block[bi]["func"] = [];
				block[bi]["do1t"] = false;
				if ( (typeof( carg[cai] ) == "function") && (typeof( carg[cai+1] ) == "string") ) {
					block[bi]["cond"] = carg[cai++];
					block[bi]["goto"] = carg[cai++];
				}
				bi++;
			}
			else if ( carg[cai] == "loop if" ) {
				block[bi] = [];
				block[bi]["what"] = carg[cai++];
				block[bi]["span"] = 0;
				block[bi]["func"] = [];
				block[bi]["do1t"] = false;
				bi++;
			}
			else if ( carg[cai] == "goto" ) {
				block[bi] = [];
				block[bi]["what"] = carg[cai++];
				block[bi]["span"] = 0;
				block[bi]["func"] = [];
				block[bi]["do1t"] = false;
				if ( typeof( carg[cai+1] ) == "string" ) {
					block[bi]["goto"] = carg[cai++];
				}
				bi++;
			}
			else if ( carg[cai] == "label" ) {
				block[bi] = [];
				block[bi]["what"] = carg[cai++];
				block[bi]["span"] = 0;
				block[bi]["func"] = [];
				block[bi]["do1t"] = false;
				if ( typeof( carg[cai+1] ) == "string" ) {
					block[bi]["name"] = carg[cai++];
				}
				bi++;
			}
			else if ( carg[cai] == "do" ) {
				block[bi] = [];
				block[bi]["what"] = carg[cai++];
				block[bi]["span"] = 0;
				block[bi]["func"] = [];
				block[bi]["do1t"] = true;
				{
					var fi = 0;
					while ( typeof( carg[cai] ) == "function" ) {
						block[bi]["func"][fi++] = carg[cai++];
					}
				}
				bi++;
			}
			else {
				if ( callback != null ) setTimeout( callback, 0 );
				return;
			}
		}
	}
	
	var itv = jamIV;
	//if ( jamSP ) itv = jamIV * 2;
	
	var bi = 0;
	var func_r = [];
	
	var loop = 1;
	var li = 1;
	
	var ac = jamAC++;
	jamAT[ac] = [];
	jamAT[ac][0] = 0; // マイナス=完全停止、0=動作、プラス=停止点まで動作
	jamAT[ac][1] = setInterval( function() {
		while ( true ) {
			// 初回ループ時、ループ数初期化
			if ( li == 1 ) {
				loop = Math.floor( block[bi]["span"] / itv ) - 1;
			}
			
			if ( jamAT[ac][0] != 0 ) { // 終了命令が出ている
				loop = li;
			}
			
			// ブロックループ処理
			if ( li < loop ) { // ブロック処理ループ中
				if ( block[bi]["do1t"] == false ) { // 実行が一度のみではない場合
					var t = jamCurveMode( li / loop, block[bi]["mode"] ); // 現在のタイミング曲線の値を取得
					for ( var i = 0; i < block[bi]["func"].length; i++ ) { // このブロックの全ての関数を呼び出し
						if ( func_r[i][1] && jamWK ) { // トランジション処理する
							if ( li == 1 ) { // 初回ループのみ
								if ( func_r[i][2] != null ) func_r[i][2].style[jamTransitionBP()] = "all "+block[bi]["span"]+"ms "+block[bi]["mode"]+" 0"; // トランジション処理の設定
								block[bi]["func"][i]( 1 );
							}
						}
						else { // トランジション処理しない
							if ( (0.0 < t) && (t < 1.0) ) { // 実行は  t がこの範囲のみ
								block[bi]["func"][i]( t );
							}
						}
					}
				}
				li++;
				break; // インターバルへ
			}
			else { // ブロック処理の終わり
				if ( block[bi]["do1t"] == false ) { // 実行が一度のみではない場合
					for ( var i = 0; i < block[bi]["func"].length; i++ ) { // このブロックの全ての関数を呼び出し
						if ( func_r[i][1] && jamWK ) { // トランジション処理する
							if ( li == 1 ) { // 初回ループのみ
								if ( func_r[i][2] != null ) func_r[i][2].style[jamTransitionBP()] = ""; // トランジション処理のクリア
								block[bi]["func"][i]( 1 );
							}
						}
						else { // トランジション処理しない
							block[bi]["func"][i]( 1 );
						}
					}
				}
				li++;
			}
			
			// 終わったブロック処理への対応
			var brk = false;
			if ( block[bi]["what"] == "time" ) {
				bi++;
				brk = true; // インターバルへ
			}
			else if ( block[bi]["what"] == "back" ) {
				if ( jamAT[ac][0] != 0 ) { // 終了命令が出ている
					bi++;
				}
				else if ( (block[bi]["loop"] < 0) || (0 < block[bi]["loop"]--) ) {
					bi -= block[bi]["move"];
					if ( bi < 0 ) bi = 0;
					li = 1;
				}
				else {
					bi++;
				}
				brk = true; // インターバルへ
			}
			else if ( block[bi]["what"] == "stop" ) {
				bi++;
				if ( 0 < jamAT[ac][0] ) { // 終了命令（停止点まで）なら
					jamAT[ac][0] = 0; // 終了命令クリア
				}
				brk = true; // インターバルへ
			}
			else if ( block[bi]["what"] == "if" ) {
				if ( block[bi]["cond"]() ) {
					block[bi]["proc"]();
				}
				bi++;
				brk = true; // インターバルへ
			}
			else if ( block[bi]["what"] == "if goto" ) {
				var hit = false;
				if ( block[bi]["cond"]() ) {
					for ( var i = 0; i < block.length; i++ ) { // ラベルを探してジャンプ
						if ( block[i]["what"] == "label" ) {
							if ( block[i]["name"] == block[bi]["goto"] ) {
								bi = i;
								hit = true;
								break;
							}
						}
					}
				}
				if ( !hit ) { // ラベルが見つからなかった
					bi++;
				}
				brk = true; // インターバルへ
			}
			else if ( block[bi]["what"] == "loop if" ) {
				var hit = false;
				for ( var i = bi - 1; 0 <= i; i-- ) { // 先頭の  if を探してジャンプ
					if ( (block[i]["what"] != "if") && (block[i]["what"] != "if goto") ) {
						bi = i + 1;
						hit = true;
						break;
					}
				}
				if ( !hit ) { // 先頭の  if が見つからなかった
					bi++;
				}
				brk = true; // インターバルへ
			}
			else if ( block[bi]["what"] == "goto" ) {
				var hit = false;
				for ( var i = 0; i < block.length; i++ ) { // ラベルを探してジャンプ
					if ( block[i]["what"] == "label" ) {
						if ( block[i]["name"] == block[bi]["goto"] ) {
							bi = i;
							hit = true;
							break;
						}
					}
				}
				if ( !hit ) { // ラベルが見つからなかった
					bi++;
				}
				brk = true; // インターバルへ
			}
			else if ( block[bi]["what"] == "label" ) {
				bi++;
				brk = true; // インターバルへ
			}
			else if ( block[bi]["what"] == "do" ) {
				bi++;
				brk = true; // インターバルへ
			}
			
			// 次のブロック処理の準備
			if ( block[bi] == null ) {
				clearInterval( jamAT[ac][1] ); jamAT[ac][1] = null;
				if ( callback != null ) setTimeout( callback, 0 );
				return;
			}
			func_r = [];
			for ( var i = 0; i < block[bi]["func"].length; i++ ) { // i=0 実行（初期化）
				var r = block[bi]["func"][i]( 0 ); // r[0]=所要時間（通常は０）、r[1]=トランジション処理、r[2]=要素オブジェクト
				if ( r == null ) r = []; if ( r[0] == null ) r[0] = 0; if ( r[1] == null ) r[1] = false; if ( r[2] == null ) r[2] = null;
				//if ( r[1] && jamWK ) if ( r[2] != null ) r[2].style[jamTransitionBP()] = "";
				func_r[i] = r; if ( block[bi]["span"] < func_r[i][0] ) block[bi]["span"] = func_r[i][0]; // 実行の所要時間が可変の場合に対応
			}
			li = 1;
			
			// インターバルへ
			if ( jamAT[ac][0] == 0 ) { // 終了命令が出ていない
				if ( brk ) break;
			}
		}
	}, itv );
}

function jamStopAnime() {
	for ( var i = 0; i < jamAC; i++ ) {
		if ( jamAT[i][1] != null ) {
			jamAT[i][0] = 1;
		}
	}
}

function jamEndAnime() {
	for ( var i = 0; i < jamAC; i++ ) {
		if ( jamAT[i][1] != null ) {
			jamAT[i][0] = -1;
		}
	}
}

function jamClearAnime() {
	for ( var i = 0; i < jamAC; i++ ) {
		if ( jamAT[i][1] != null ) {
			clearInterval( jamAT[i][1] );
		}
	}
	jamAC = 0;
	jamAT = [];
}

function jamQBC( x2, y2 , x3, y3 ) {
	var step;
	var err = 0.001;
	
 	x2 *= 3; y2 *= 3;
 	x3 *= 3; y3 *= 3;
	
	return function ( t ) {
		var p = step || t;
		var a, b, c, d, x, s;
		
		do {
			a = 1 - p;
			b = a * a;
			c = p * p;
			d = c * p;
			
			x = x2 * b * p + x3 * a * c + d;
			s = t - x;
			p += s * 0.5;
		} while ( err < Math.abs( s ) );
		
		step = p;
		return  y2 * b * p + y3 * a * c + d;
	};
}

function jamCurveMode( t, mode ) {
	if ( (0 < t) && (t < 1) ) {
		var func = jamQBC( 0.25, 0.1, 0.25, 1.0 );
		return func( t );
	}
	return t;
}

function jacNone() {
	var func = function( i ) {
		return [0, false, null]; // 0=所要時間（通常は０）、false=トランジション処理、null=要素オブジェクト
	};
	return func;
}

function jacTransform( elem, sc, ro, tr, wk ) {
	if ( sc[0] == null ) sc[0] = 1; if ( sc[1] == null ) sc[1] = 1; if ( sc[2] == null ) sc[2] = sc[0]; if ( sc[3] == null ) sc[3] = sc[1];
	if ( ro[0] == null ) ro[0] = 0; if ( ro[1] == null ) ro[1] = 0;
	if ( tr[0] == null ) tr[0] = 0; if ( tr[1] == null ) tr[1] = 0; if ( tr[2] == null ) tr[2] = tr[0]; if ( tr[3] == null ) tr[3] = tr[1];
	if ( wk == null ) wk = true;
	var func = function( i ) {
		if ( !wk || (0 < i) ) {
			elem.style[jamTransformBP()] = 
			"scale("+(sc[0]+((sc[1]-sc[0])*i))+","+(sc[2]+((sc[3]-sc[2])*i))+")"+
			" rotate("+(ro[0]+((ro[1]-ro[0])*i))+"deg)"+
			" translate("+(tr[0]+((tr[1]-tr[0])*i))+"px,"+(tr[2]+((tr[3]-tr[2])*i))+"px)";
		}
		return [0, wk, elem];
	};
	return func;
}

function jacTransformEx( elem, sc, ro, tr, wk ) { // 「処理の最終値」と「現在の値」が違う場合に処理する
	if ( sc[0] == null ) sc[0] = 1; if ( sc[1] == null ) sc[1] = 1; if ( sc[2] == null ) sc[2] = sc[0]; if ( sc[3] == null ) sc[3] = sc[1];
	if ( ro[0] == null ) ro[0] = 0; if ( ro[1] == null ) ro[1] = 0;
	if ( tr[0] == null ) tr[0] = 0; if ( tr[1] == null ) tr[1] = 0; if ( tr[2] == null ) tr[2] = tr[0]; if ( tr[3] == null ) tr[3] = tr[1];
	if ( wk == null ) wk = true;
	var func = function( i ) {
		var s = elem.style[jamTransformBP()]; s = s.replace( / /g, "" ); s = s.replace( /scale\(1\)/g, "scale(1,1)" );
		var s1 = "scale("+(sc[1])+","+(sc[3])+")"+"rotate("+(ro[1])+"deg)"+"translate("+(tr[1])+"px,"+(tr[3])+"px)";
		if ( (s == "") && (sc[1] == 1) && (sc[3] == 1) && (ro[1] == 0) && (tr[1] == 0) && (tr[3] == 0) ) s = s1; // トランスフォーム設定が無い場合
//console.log( "s  = " + s )
//console.log( "s1 = " + s1 )
		if ( s != s1 ) {
			if ( !wk || (0 < i) ) {
				elem.style[jamTransformBP()] = 
				"scale("+(sc[0]+((sc[1]-sc[0])*i))+","+(sc[2]+((sc[3]-sc[2])*i))+")"+
				" rotate("+(ro[0]+((ro[1]-ro[0])*i))+"deg)"+
				" translate("+(tr[0]+((tr[1]-tr[0])*i))+"px,"+(tr[2]+((tr[3]-tr[2])*i))+"px)";
			}
		}
		return [0, wk, elem];
	};
	return func;
}

function jacTransformArray( elems, sc, ro, tr, wk ) {
	if ( sc[0] == null ) sc[0] = 1; if ( sc[1] == null ) sc[1] = 1; if ( sc[2] == null ) sc[2] = sc[0]; if ( sc[3] == null ) sc[3] = sc[1];
	if ( ro[0] == null ) ro[0] = 0; if ( ro[1] == null ) ro[1] = 0;
	if ( tr[0] == null ) tr[0] = 0; if ( tr[1] == null ) tr[1] = 0; if ( tr[2] == null ) tr[2] = tr[0]; if ( tr[3] == null ) tr[3] = tr[1];
	if ( wk == null ) wk = true;
	var func = function( i ) {
		var elem = null;
		var j = elems[0].getAttribute( "LastIndex" );
		if ( j != null ) {
			elem = elems[j];
			if ( !wk || (0 < i) ) {
				elem.style[jamTransformBP()] = 
				"scale("+(sc[0]+((sc[1]-sc[0])*i))+","+(sc[2]+((sc[3]-sc[2])*i))+")"+
				" rotate("+(ro[0]+((ro[1]-ro[0])*i))+"deg)"+
				" translate("+(tr[0]+((tr[1]-tr[0])*i))+"px,"+(tr[2]+((tr[3]-tr[2])*i))+"px)";
			}
		}
		return [0, wk, elem];
	};
	return func;
}

function jacTransformScale( elem, sc, wk ) {
	if ( sc[0] == null ) sc[0] = 1; if ( sc[1] == null ) sc[1] = 1; if ( sc[2] == null ) sc[2] = sc[0]; if ( sc[3] == null ) sc[3] = sc[1];
	if ( wk == null ) wk = true;
	var func = function( i ) {
		if ( !wk || (0 < i) ) {
			elem.style[jamTransformBP()] = 
			"scale("+(sc[0]+((sc[1]-sc[0])*i))+","+(sc[2]+((sc[3]-sc[2])*i))+")";
		}
		return [0, wk, elem];
	};
	return func;
}

function jacTransformRotate( elem, ro, wk ) {
	if ( ro[0] == null ) ro[0] = 0; if ( ro[1] == null ) ro[1] = 0;
	if ( wk == null ) wk = true;
	var func = function( i ) {
		if ( !wk || (0 < i) ) {
			elem.style[jamTransformBP()] = 
			"rotate("+(ro[0]+((ro[1]-ro[0])*i))+"deg)";
		}
		return [0, wk, elem];
	};
	return func;
}

function jacTransformTranslate( elem, tr, wk ) {
	if ( tr[0] == null ) tr[0] = 0; if ( tr[1] == null ) tr[1] = 0; if ( tr[2] == null ) tr[2] = tr[0]; if ( tr[3] == null ) tr[3] = tr[1];
	if ( wk == null ) wk = true;
	var func = function( i ) {
		if ( !wk || (0 < i) ) {
			elem.style[jamTransformBP()] = 
			"translate("+(tr[0]+((tr[1]-tr[0])*i))+"px,"+(tr[2]+((tr[3]-tr[2])*i))+"px)";
		}
		return [0, wk, elem];
	};
	return func;
}

function jacOpacity( elem, op, wk ) {
	if ( op[0] == null ) op[0] = 1; if ( op[1] == null ) op[1] = 1;
	if ( wk == null ) wk = true;
	var func = function( i ) {
		if ( !wk || (0 < i) ) {
			elem.style.opacity = (op[0]+((op[1]-op[0])*i));
		}
		return [0, wk, elem];
	};
	return func;
}

function jacOpacityArray( elems, op, wk ) {
	if ( op[0] == null ) op[0] = 1; if ( op[1] == null ) op[1] = 1;
	if ( wk == null ) wk = true;
	var func = function( i ) {
		var elem = null;
		var j = elems[0].getAttribute( "LastIndex" );
		if ( j != null ) {
			if ( !wk || (0 < i) ) {
				elems[j].style.opacity = (op[0]+((op[1]-op[0])*i));
			}
			elem = elems[j];
		}
		return [0, wk, elem];
	};
	return func;
}

function jacOpacityEx( elem, op, wk ) { // 「処理の最終値」と「現在の値」が違う場合に処理する
	if ( op[0] == null ) op[0] = 1; if ( op[1] == null ) op[1] = 1;
	if ( wk == null ) wk = true;
	var func = function( i ) {
		if ( elem.style.opacity != op[1] ) {
			if ( !wk || (0 < i) ) {
				elem.style.opacity = (op[0]+((op[1]-op[0])*i));
			}
		}
		return [0, wk, elem];
	};
	return func;
}

function jacOpacityEy( elem1, attr, limit, elem2, op, wk ) { // attr が  limit 以下で処理する
	if ( op[0] == null ) op[0] = 1; if ( op[1] == null ) op[1] = 1;
	if ( wk == null ) wk = true;
	var func = function( i ) {
		if ( elem1.getAttribute( attr ) <= limit ) {
			if ( elem2.style.opacity != op[1] ) {
				if ( !wk || (0 < i) ) {
					elem2.style.opacity = (op[0]+((op[1]-op[0])*i));
				}
			}
		}
		return [0, wk, elem2];
	};
	return func;
}

function jacColor( elem, rgb, wk ) {
	if ( rgb[0] == null ) rgb[0] = 0; if ( rgb[1] == null ) rgb[1] = 0; if ( rgb[2] == null ) rgb[2] = rgb[0]; if ( rgb[3] == null ) rgb[3] = rgb[1]; if ( rgb[4] == null ) rgb[4] = rgb[2]; if ( rgb[5] == null ) rgb[5] = rgb[3];
	if ( wk == null ) wk = true;
	var func = function( i ) {
		if ( !wk || (0 < i) ) {
			elem.style.color = "rgb("+Math.floor(rgb[0]+((rgb[1]-rgb[0])*i))+","+Math.floor(rgb[2]+((rgb[3]-rgb[2])*i))+","+Math.floor(rgb[4]+((rgb[5]-rgb[4])*i))+")";
		}
		return [0, wk, elem];
	};
	return func;
}

function jacBackgroundColor( elem, rgb, wk ) {
	if ( wk == null ) wk = true;
	if ( rgb[0] == null ) rgb[0] = 0; if ( rgb[1] == null ) rgb[1] = 0; if ( rgb[2] == null ) rgb[2] = rgb[0]; if ( rgb[3] == null ) rgb[3] = rgb[1]; if ( rgb[4] == null ) rgb[4] = rgb[2]; if ( rgb[5] == null ) rgb[5] = rgb[3];
	var func = function( i ) {
		if ( !wk || (0 < i) ) {
			elem.style.backgroundColor = "rgb("+Math.floor(rgb[0]+((rgb[1]-rgb[0])*i))+","+Math.floor(rgb[2]+((rgb[3]-rgb[2])*i))+","+Math.floor(rgb[4]+((rgb[5]-rgb[4])*i))+")";
		}
		return [0, wk, elem];
	};
	return func;
}

function jacScroll( elem, top ) {
	if ( top == null ) top = 1.0;
	var func = function( i ) {
		var scroll = elem.scrollHeight - (elem.scrollTop * top); 
		wHis.scrollTop += scroll * (i / 10);
		return [0, false, elem];
	};
	return func;
}

function jacText( elem, tx, ali, vali, itv ) {
	if ( ali == null ) ali = ""; else ali = "align = '"+ali+"'";
	if ( vali == null ) vali = ""; else vali = "valign = '"+vali+"'";
	if ( itv == null ) itv = 0;
	if ( itv == 0 ) {
		var func = function( i ) {
			if ( i == 0 ) {
				elem.innerHTML = "<table style='width:100%;'><tr><td "+ali+" "+vali+">"+tx+"</td></tr></table>";
			}
			return [0, false, null];
		};
	}
	else { // こちらは未完成（タグまたぎ、禁則関連で表示がガタつく）
		//itv = 2000; // デバッグ用にゆっくり表示
		var len = tx.length;
		var span = itv * len;
		var func = function( i ) {
			var disp_len = Math.ceil( (i * 1.0) * len );
			var disp_str = tx.substr( 0, disp_len );
			var remain_str = tx.substr( disp_len, len );
			for ( var i = disp_len; i < len; i++ ) {
				if ( disp_str.lastIndexOf( ">" ) < disp_str.lastIndexOf( "<" ) ) { disp_len += 1; }
				else if ( disp_str.lastIndexOf( "</b>" ) < disp_str.lastIndexOf( "<b>" ) ) { disp_str = disp_str + "</b>"; remain_str = "<b>" + remain_str; break; }
				else if ( disp_str.lastIndexOf( "</em>" ) < disp_str.lastIndexOf( "<em>" ) ) { disp_str = disp_str + "</em>"; remain_str = "<em>" + remain_str; break; }
				else { break; }
				disp_str = tx.substr( 0, disp_len );
				remain_str = tx.substr( disp_len, len );
			} // <span style='opacity:0.0;'>"+tx.substr( disp_len, len )+"</span>
			elem.innerHTML = "<table style='width:100%;'><tr><td "+ali+" "+vali+">"+disp_str+"<span style='opacity:0.0;'>"+remain_str+"</span></td></tr></table>";
			return [span / 2.5, false, null];
		};
	}
	return func;
}

function jacTextEx( elem, attr, ali, vali, itv ) {
	if ( ali == null ) ali = ""; else ali = "align = '"+ali+"'";
	if ( vali == null ) vali = ""; else vali = "valign = '"+vali+"'";
	if ( itv == null ) itv = 0;
	if ( itv == 0 ) {
		var func = function( i ) {
			if ( i == 0 ) {
				var tx = elem.getAttribute( attr );
				if ( tx == null ) tx = "";
				elem.innerHTML = "<table style='width:100%;'><tr><td "+ali+" "+vali+">"+tx+"</td></tr></table>";
			}
			return [0, false, null];
		};
	}
	else {
		var func = jacNone();
	}
	return func;
}

function jacImage( elem, im ) {
	var func = function( i ) {
		if ( i == 0 ) {
			elem.innerHTML = "<img style='width:100%;height:100%;' src='"+im+"'>"; elem.style.display = "";
		}
		return [0, false, null];
	};
	return func;
}

function jacImageArray( elems, im ) {
	var func = function( i ) {
		if ( i == 0 ) {
			for ( var j = 0; j < elems.length; j++ ) {
				if ( elems[j].style.opacity == 0 ) {
					elems[j].innerHTML = "<img style='width:100%;height:100%;' src='"+im+"'>"; elems[j].style.display = "";
					elems[0].setAttribute( "LastIndex", j );
					break;
				}
			}
		}
		return [0, false, null];
	};
	return func;
}

function jacImageCopy( elem1, elem2, t, op ) {
	if ( t == null ) t = 0;
	if ( op == null ) op = 1;
	var func = function( i ) {
		if ( i == t )  {
			elem2.innerHTML = elem1.innerHTML; elem2.style.display = "";
			elem2.style.opacity = op;
			elem2.style[jamTransformBP()] = "";
			elem2.style[jamTransitionBP()] = "";
		}
		return [0, false, null];
	};
	return func;
}

function jacImageDelete( elem, t ) {
	if ( t == null ) t = 0.0;
	var func = function( i ) {
		if ( i == t )  {
			elem.innerHTML = ""; elem.style.display = "";
			elem.style.opacity = 0;
		}
		return [0, false, null];
	};
	return func;
}

function jacClear( elem, t ) {
	if ( t == null ) t = 0.0;
	var func = function( i ) {
		if ( i == t )  {
			elem.innerHTML = ""; elem.style.display = "";
			elem.style.opacity = 0;
			elem.style[jamTransformBP()] = "";
			elem.style[jamTransitionBP()] = "";
		}
		return [0, false, null];
	};
	return func;
}

function jacClearArray( elems, t ) {
	if ( t == null ) t = 0.0;
	var func = function( i ) {
		if ( i == t )  {
			var j = elems[0].getAttribute( "LastIndex" );
			if ( j != null ) {
				for ( var k = 0; k < j; k++ ) {
					elems[k].innerHTML = ""; elems[k].style.display = "";
					elems[k].style.opacity = 0;
					elems[k].style[jamTransformBP()] = "";
					elems[k].style[jamTransitionBP()] = "";
				}
			}
		}
		return [0, false, null];
	};
	return func;
}

function jacDivTransform( div, sc, ro, tr, wk ) {
	if ( sc[0] == null ) sc[0] = 1; if ( sc[1] == null ) sc[1] = 1; if ( sc[2] == null ) sc[2] = sc[0]; if ( sc[3] == null ) sc[3] = sc[1];
	if ( ro[0] == null ) ro[0] = 0; if ( ro[1] == null ) ro[1] = 0;
	if ( tr[0] == null ) tr[0] = 0; if ( tr[1] == null ) tr[1] = 0; if ( tr[2] == null ) tr[2] = tr[0]; if ( tr[3] == null ) tr[3] = tr[1];
	var a = [];
	if ( div instanceof Array ) {
		for ( var i = 0; i < div.length; i++ ) {
			a.push( jacTransform( div[i], sc, ro, tr, wk ) )
		}
	}
	else {
		a.push( jacTransform( div, sc, ro, tr, wk ) )
	}
	return a;
}

function jacDivTransformEx( div, sc, ro, tr, wk ) {
	if ( sc[0] == null ) sc[0] = 1; if ( sc[1] == null ) sc[1] = 1; if ( sc[2] == null ) sc[2] = sc[0]; if ( sc[3] == null ) sc[3] = sc[1];
	if ( ro[0] == null ) ro[0] = 0; if ( ro[1] == null ) ro[1] = 0;
	if ( tr[0] == null ) tr[0] = 0; if ( tr[1] == null ) tr[1] = 0; if ( tr[2] == null ) tr[2] = tr[0]; if ( tr[3] == null ) tr[3] = tr[1];
	var a = [];
	if ( div instanceof Array ) {
		for ( var i = 0; i < div.length; i++ ) {
			a.push( jacTransformEx( div[i], sc, ro, tr, wk ) )
		}
	}
	else {
		a.push( jacTransformEx( div, sc, ro, tr, wk ) )
	}
	return a;
}

function jacDivOpacity( div, op, wk ) {
	if ( op == null ) op = [];
	if ( op[0] == null ) op[0] = 1; if ( op[1] == null ) op[1] = 0;
	var a = [];
	if ( div instanceof Array ) {
		for ( var i = 0; i < div.length; i++ ) {
			a.push( jacOpacity( div[i], op, wk ) )
		}
	}
	else {
		a.push( jacOpacity( div, op, wk ) )
	}
	return a;
}

function jacDivOpacityEx( div, op, wk ) {
	if ( op == null ) op = [];
	if ( op[0] == null ) op[0] = 1; if ( op[1] == null ) op[1] = 0;
	var a = [];
	if ( div instanceof Array ) {
		for ( var i = 0; i < div.length; i++ ) {
			a.push( jacOpacityEx( div[i], op, wk ) )
		}
	}
	else {
		a.push( jacOpacityEx( div, op, wk ) )
	}
	return a;
}

function jacDivImage( div, image, op, wk ) {
	if ( op == null ) op = [];
	if ( op[0] == null ) op[0] = 0; if ( op[1] == null ) op[1] = 1;
	var a = [];
	if ( div instanceof Array ) {
		for ( var i = 0; i < div.length; i++ ) {
			a.push( jacImage( div[i], image ) );
			a.push( jacOpacity( div[i], op, wk ) );
		}
	}
	else {
		a.push( jacImage( div, image ) );
		a.push( jacOpacity( div, op, wk ) );
	}
	return a;
}

function jacDivImageCopy( div1, div2, t, op ) {
	var a = [];
	if ( div1 instanceof Array ) {
		for ( var i = 0; i < div1.length; i++ ) {
			if ( div2 instanceof Array ) {
				for ( var j = 0; j < div2.length; j++ ) {
					a.push( jacImageCopy( div1[i], div2[j], t, op ) );
				}
			}
			else {
				a.push( jacImageCopy( div1[i], div2, t, op ) );
			}
		}
	}
	else {
		if ( div2 instanceof Array ) {
			for ( var j = 0; j < div2.length; j++ ) {
				a.push( jacImageCopy( div1, div2[j], t, op ) );
			}
		}
		else {
			a.push( jacImageCopy( div1, div2, t, op ) );
		}
	}
	return a;
}

function jacDivImageDelete( div, t ) {
	var a = [];
	if ( div instanceof Array ) {
		for ( var i = 0; i < div.length; i++ ) {
			a.push( jacImageDelete( div[i], t ) );
		}
	}
	else {
		a.push( jacImageDelete( div, t ) );
	}
	return a;
}

function jacDivClear( div, t ) {
	var a = [];
	if ( div instanceof Array ) {
		for ( var i = 0; i < div.length; i++ ) {
			a.push( jacClear( div[i], t ) );
		}
	}
	else {
		a.push( jacClear( div, t ) );
	}
	return a;
}

function jacDivTextOp( div, text, op, ali, vali ) {
	if ( op == null ) op = [];
	if ( op[0] == null ) op[0] = 0; if ( op[1] == null ) op[1] = 1;
	var a = [];
	if ( div instanceof Array ) {
		for ( var i = 0; i < div.length; i++ ) {
			a.push( jacText( div[i], text, ali, vali ) );
			a.push( jacOpacity( div[i], op ) );
		}
	}
	else {
		a.push( jacText( div, text, ali, vali ) );
		a.push( jacOpacity( div, op ) );
	}
	return a;
}

function jacDivTextTw( div, text, itv, op, ali, vali ) {
	if ( itv == null ) itv = 300;
	if ( op == null ) op = [];
	if ( op[0] == null ) op[0] = 0.5; if ( op[1] == null ) op[1] = 1;
	var a = [];
	if ( div instanceof Array ) {
		for ( var i = 0; i < div.length; i++ ) {
			a.push( jacText( div[i], text, ali, vali, itv ) );
			a.push( jacOpacity( div[i], op ) );
		}
	}
	else {
		a.push( jacText( div, text, ali, vali, itv ) );
		a.push( jacOpacity( div, op ) );
	}
	return a;
}

function jamGetZIndex( elem ) {
	var s; var z;
	if (elem.currentStyle) {
		s = elem.currentStyle;
		return s["zIndex"];
	}
	if ( window.getComputedStyle ) {
		s = window.getComputedStyle( elem, null )
		return s.getPropertyValue( 'z-index' );
	}
	return null;
}

window.onload = function() {
	jamInit();
	
	try {
		document.body.removeChild( document.getElementById( "SystemBootNotice" ) );
	} catch( e ) {}
	
	jamRootDiv();
	var e = document.createElement( "script" ); e.id = "SystemJavaScript";
	e.type = "text/javascript";
	e.src = "start.js";
	e.onload = function(){ setTimeout( jamBoot, 0 ); };
	document.head.appendChild( e );
	
	jamGetRootElem().style.backgroundColor = "black";
	
	//setTimeout( jamBoot, 1000 );
}

function jamBoot() {
	jamStart();
	//alert( "jamBoot()" );
}

var jamRT = "";
function jamGetReturn() { return jamRT; }
function jamReturn( next ) {
	jamClearAnime();
	
	try {
		document.head.removeChild( document.getElementById( "SystemJavaScript" ) );
	} catch( e ) {}
	
	jamRootDiv();
	var e = document.createElement( "script" ); e.id = "SystemJavaScript";
	e.type = "text/javascript";
	e.src = next;
	e.onload = function(){ setTimeout( jamBoot, 0 ); };
	document.head.appendChild( e );
	
	jamRT = next;
	
	//setTimeout( jamBoot, 1000 );
}
